/* 
 * seta43
 * Juan Galaz
 * http: / / seta43.duckdns.org
 * http: / / seta43.blogspot.com 
 * 2021
 * Reloj - WS2812B
*/

#include <Adafruit_NeoPixel.h>
#include <avr/power.h>


#define HORAS       14            
#define MINUTOS     15
#define COLOR     16           


#define PIN 13
#define NUMPIXELS  29

Adafruit_NeoPixel pixels(NUMPIXELS, PIN, NEO_GRB + NEO_KHZ800);

#define APAGADO 0
unsigned char BRIr,BRIg,BRIb;

char minutos1,minutos0,horas1,horas0,segundos;
char modo;


void setup() 
{
  Serial.begin(9600);        // connect to the serial port
  Serial.println(" RELOJ LCD ");

  pinMode(HORAS,INPUT_PULLUP);
  digitalWrite(HORAS,HIGH);
  pinMode(MINUTOS,INPUT_PULLUP);
  digitalWrite(MINUTOS,HIGH);
  pinMode(COLOR,INPUT_PULLUP);
  digitalWrite(COLOR,HIGH);
  
  pixels.begin(); 
  
  modo=100;  changeColor();
  displayDigi(); 
}

void loop() 
{
    segundos++;
    if(segundos>59)
      {
        segundos=0;
        changeMinutos();
      }
      
    delay(500);
    printPunto(1);
    delay(500);
    printPunto(0);

    while(digitalRead(HORAS) == LOW)
    {
          horas0++;
          if(horas0>9)
            {
              horas0=0;    horas1++;
              if(horas0==4 && horas1==2) {   horas0=0;  horas1=0;  }
            }
      displayDigi();    
      delay(300);
    }

    while(digitalRead(MINUTOS) == LOW)
    {
       minutos0++;
       if(minutos0>9)
       {
          minutos0=0;   minutos1++;
          if(minutos1>5)  { minutos0=0;   minutos1=0;  }
       }
      displayDigi(); 
      delay(300);
    }

    while(digitalRead(COLOR) == LOW)
    {
      changeColor(); 
      delay(700);
    }
  
}

void changeColor(void)
{
  modo++;
  if(modo>7)modo=0;
  switch(modo)
  {
    case 0:
      BRIr=20; BRIg=20; BRIb=20;
    break;
    case 1:
      BRIr=255; BRIg=255; BRIb=255;
    break;
    case 2:
      BRIr=20; BRIg=0; BRIb=0;
    break;
    case 3:
      BRIr=255; BRIg=0; BRIb=0;
    break;
    case 4:
      BRIr=0; BRIg=20; BRIb=0;
    break;
    case 5:
      BRIr=0; BRIg=255; BRIb=0;
    break;
    case 6:
      BRIr=0; BRIg=0; BRIb=20;
    break;
    case 7:
      BRIr=0; BRIg=0; BRIb=255;
    break;
  
  }
  displayDigi();
  pixels.show();
}

void displayDigi(void)
{
    printDigito(minutos0,3);
    printDigito(minutos1,2);
    printDigito(horas0,1);
    printDigito(horas1,0);
}


void changeMinutos(void)
{
  minutos0++;
     if(minutos0>9)
     {
      minutos0=0;
      minutos1++;
      if(minutos1>5)
        {
          minutos0=0;
          minutos1=0;
          horas0++;
          if(horas0>9)
            {
              horas0=0;
              horas1++;
            }
          if(horas0==4 && horas1==2)
            {
              horas0=0;
              horas1=0;
            }
        }
     }
     
   displayDigi(); 
}

void printPunto(unsigned char num)
{
  if(num==0)
         pixels.setPixelColor(28, pixels.Color(0,0,0));
     else
         pixels.setPixelColor(28, pixels.Color(BRIr,BRIg,BRIb));
  pixels.show();
}

void printDigito(unsigned char num,unsigned char digi )
{
  digi*=7;

  switch(num)
    {
      case 0:
         pixels.setPixelColor(0+digi, pixels.Color(BRIr,BRIg,BRIb));
         pixels.setPixelColor(1+digi, pixels.Color(BRIr,BRIg,BRIb));
         pixels.setPixelColor(2+digi, pixels.Color(BRIr,BRIg,BRIb));
         pixels.setPixelColor(3+digi, pixels.Color(0,0,0));
         pixels.setPixelColor(4+digi, pixels.Color(BRIr,BRIg,BRIb));
         pixels.setPixelColor(5+digi, pixels.Color(BRIr,BRIg,BRIb));
         pixels.setPixelColor(6+digi, pixels.Color(BRIr,BRIg,BRIb));     
      break;
      case 1:
         pixels.setPixelColor(0+digi, pixels.Color(0,0,0));
         pixels.setPixelColor(1+digi, pixels.Color(0,0,0));
         pixels.setPixelColor(2+digi, pixels.Color(0,0,0));
         pixels.setPixelColor(3+digi, pixels.Color(0,0,0));
         pixels.setPixelColor(4+digi, pixels.Color(0,0,0));
         pixels.setPixelColor(5+digi, pixels.Color(BRIr,BRIg,BRIb));
         pixels.setPixelColor(6+digi, pixels.Color(BRIr,BRIg,BRIb)); 
      break;
      case 2:
         pixels.setPixelColor(0+digi, pixels.Color(0,0,0));
         pixels.setPixelColor(1+digi, pixels.Color(BRIr,BRIg,BRIb));
         pixels.setPixelColor(2+digi, pixels.Color(BRIr,BRIg,BRIb));
         pixels.setPixelColor(3+digi, pixels.Color(BRIr,BRIg,BRIb));
         pixels.setPixelColor(4+digi, pixels.Color(BRIr,BRIg,BRIb));
         pixels.setPixelColor(5+digi, pixels.Color(BRIr,BRIg,BRIb));
         pixels.setPixelColor(6+digi, pixels.Color(0,0,0)); 
      break;
      case 3:
         pixels.setPixelColor(0+digi, pixels.Color(0,0,0));
         pixels.setPixelColor(1+digi, pixels.Color(0,0,0));
         pixels.setPixelColor(2+digi, pixels.Color(BRIr,BRIg,BRIb));
         pixels.setPixelColor(3+digi, pixels.Color(BRIr,BRIg,BRIb));
         pixels.setPixelColor(4+digi, pixels.Color(BRIr,BRIg,BRIb));
         pixels.setPixelColor(5+digi, pixels.Color(BRIr,BRIg,BRIb));
         pixels.setPixelColor(6+digi, pixels.Color(BRIr,BRIg,BRIb));     
      break;
      case 4:
         pixels.setPixelColor(0+digi, pixels.Color(BRIr,BRIg,BRIb));
         pixels.setPixelColor(1+digi, pixels.Color(0,0,0));
         pixels.setPixelColor(2+digi, pixels.Color(0,0,0));
         pixels.setPixelColor(3+digi, pixels.Color(BRIr,BRIg,BRIb));
         pixels.setPixelColor(4+digi, pixels.Color(0,0,0));
         pixels.setPixelColor(5+digi, pixels.Color(BRIr,BRIg,BRIb));
         pixels.setPixelColor(6+digi, pixels.Color(BRIr,BRIg,BRIb));     
      break;
      case 5:
         pixels.setPixelColor(0+digi, pixels.Color(BRIr,BRIg,BRIb));
         pixels.setPixelColor(1+digi, pixels.Color(0,0,0));
         pixels.setPixelColor(2+digi, pixels.Color(BRIr,BRIg,BRIb));
         pixels.setPixelColor(3+digi, pixels.Color(BRIr,BRIg,BRIb));
         pixels.setPixelColor(4+digi, pixels.Color(BRIr,BRIg,BRIb));
         pixels.setPixelColor(5+digi, pixels.Color(0,0,0));
         pixels.setPixelColor(6+digi, pixels.Color(BRIr,BRIg,BRIb));     
      break;
       case 6:
         pixels.setPixelColor(0+digi, pixels.Color(BRIr,BRIg,BRIb));
         pixels.setPixelColor(1+digi, pixels.Color(BRIr,BRIg,BRIb));
         pixels.setPixelColor(2+digi, pixels.Color(BRIr,BRIg,BRIb));
         pixels.setPixelColor(3+digi, pixels.Color(BRIr,BRIg,BRIb));
         pixels.setPixelColor(4+digi, pixels.Color(BRIr,BRIg,BRIb));
         pixels.setPixelColor(5+digi, pixels.Color(0,0,0));
         pixels.setPixelColor(6+digi, pixels.Color(BRIr,BRIg,BRIb));     
      break;
      case 7:
         pixels.setPixelColor(0+digi, pixels.Color(0,0,0));
         pixels.setPixelColor(1+digi, pixels.Color(0,0,0));
         pixels.setPixelColor(2+digi, pixels.Color(0,0,0));
         pixels.setPixelColor(3+digi, pixels.Color(0,0,0));
         pixels.setPixelColor(4+digi, pixels.Color(BRIr,BRIg,BRIb));
         pixels.setPixelColor(5+digi, pixels.Color(BRIr,BRIg,BRIb));
         pixels.setPixelColor(6+digi, pixels.Color(BRIr,BRIg,BRIb));     
      break;
      case 8:
         pixels.setPixelColor(0+digi, pixels.Color(BRIr,BRIg,BRIb));
         pixels.setPixelColor(1+digi, pixels.Color(BRIr,BRIg,BRIb));
         pixels.setPixelColor(2+digi, pixels.Color(BRIr,BRIg,BRIb));
         pixels.setPixelColor(3+digi, pixels.Color(BRIr,BRIg,BRIb));
         pixels.setPixelColor(4+digi, pixels.Color(BRIr,BRIg,BRIb));
         pixels.setPixelColor(5+digi, pixels.Color(BRIr,BRIg,BRIb));
         pixels.setPixelColor(6+digi, pixels.Color(BRIr,BRIg,BRIb));     
      break;
      case 9:
         pixels.setPixelColor(0+digi, pixels.Color(BRIr,BRIg,BRIb));
         pixels.setPixelColor(1+digi, pixels.Color(0,0,0));
         pixels.setPixelColor(2+digi, pixels.Color(0,0,0));
         pixels.setPixelColor(3+digi, pixels.Color(BRIr,BRIg,BRIb));       
         pixels.setPixelColor(4+digi, pixels.Color(BRIr,BRIg,BRIb));
         pixels.setPixelColor(5+digi, pixels.Color(BRIr,BRIg,BRIb));
         pixels.setPixelColor(6+digi, pixels.Color(BRIr,BRIg,BRIb));     
      break;    
    }
    
    pixels.show();
}
